# -*- coding: cp1252/latin-1 -*-
"""
Created on Thu Jul 03 20:48:16 2014

@author: 2
"""
import sys, os
import numpy as np
import matplotlib.pyplot as plt
        
class Test:
    
    ''' 
    
    '''
    
    def __init__(self):
        self.pssedir = r'C:\Program Files\PTI\PSSE33'
        self.pssedir = r'C:\Program Files\PTI\PSSEUniversity33'
        
        self.pssbindir  = os.path.join(self.pssedir,'PSSBIN')

    def setup(self,case_name, case_dir, dll_dir, ps_tools_dir, dya_dir):
        '''
         Files Used
        '''
        
        self.case_dir = case_dir
        sys.path.append(ps_tools_dir)
        self.libraryname = os.path.join(dll_dir, 'dsusr.dll')
        self.rawfile    = os.path.join(case_dir,case_name + '.raw')
        self.dyrfile    = os.path.join(case_dir,case_name + '.dyr')
        self.dyafile_avr= os.path.join(case_dir, dya_dir, case_name + '_avr.dya')
        self.dyafile_gov= os.path.join(case_dir, dya_dir,case_name + '_gov.dya')
        self.dyafile_pss= os.path.join(case_dir, dya_dir,case_name + '_pss.dya')
        self.xsfile = os.path.join(case_dir,case_name + '_xs.txt')
        self.savfile    = os.path.join(case_dir,case_name + '.sav')
        self.savdynfile = os.path.join(case_dir,case_name + '_dyn.sav')
        self.snpfile    = os.path.join(case_dir,case_name + '.snp')
        self.outfile1   = os.path.join(case_dir,case_name + '.out')
        self.outfile2   = os.path.join(case_dir,case_name + '.out')
        self.outfile3   = os.path.join(case_dir,case_name + '.out')
        self.prgfile    = os.path.join(case_dir,'dyntools_demo_progress.txt')
        self.chnffile = os.path.join(case_dir,case_name + '.pkl') 
        self.lsa_file  = os.path.join(case_dir,case_name + '.lsa')
        self.lsa_dat  = os.path.join(case_dir,case_name + '.dat')
        self.ltifile = os.path.join(case_dir,'sys_abcd_f102.pkl')
        # =============================================================================================
        # Check if running from Python Interpreter
        exename = sys.executable
        p, nx   = os.path.split(exename)
        nx      = nx.lower()
        if nx in ['python.exe', 'pythonw.exe']:
            os.environ['PATH'] = self.pssbindir + ';' + os.environ['PATH']
            sys.path.insert(0,self.pssbindir)
        
        # =============================================================================================
        import dyntools
        
        import redirect
        redirect.psse2py()    
        import psspy
        ierr = psspy.psseinit(buses=80000)  # choose here bus numbers you want
        
        psspy.lines_per_page_one_device(1,90)
        psspy.progress_output(2,self.prgfile,[0,0])
        # =============================================================================================

        self.psspy = psspy
        self.dyntools = dyntools

    def setup_pf(self):
        
        # Se carga el .raw
        self.psspy.read(0,self.rawfile)
        
        # Se soluciona el flujo de potencia
        self.psspy.fdns([0,0,0,1,1,0,99,0])
        
        # Se guarda la solucion
        self.psspy.save(self.savfile)
        
        
    def setup_dyn(self):
        
        # Se cargan los datos dinamicos
        self.psspy.dyre_new([1,1,1,1],self.dyrfile,"","","")
        self.psspy.dyre_add([],self.dyafile_avr,"","")
        self.psspy.dyre_add([],self.dyafile_gov,"","")

        # Se convierten las cargas y los generadores para la simulacion dinamica
        self.psspy.cong(0)
        self.psspy.conl(0,1,1,[0,0],[0.0, 100.0,0.0, 100.0])
        self.psspy.conl(0,1,2,[0,0],[0.0, 100.0,0.0, 100.0])
        self.psspy.conl(0,1,3,[0,0],[0.0, 100.0,0.0, 100.0])
        
        # se guarda la solucion .sav para simulacion dinamica
        self.psspy.save(self.savdynfile)
        
        
        ierr = self.psspy.addmodellibrary(self.libraryname)
        
        self.vip_buses = [10]
 
        chan_ids = {
        'ANGLE': {'id':1, 'description':'machine relative rotor angle (degrees)', 'name':'theta', 'latex':'\theta'},
        'PELEC': {'id':2, 'description':'machine electrical power (pu on SBASE).', 'name':'p_gen', 'latex':'p_g'},
        'QELEC': {'id':3, 'description':'machine reactive power.', 'name':'q_gen', 'latex':'q_g'},
        'ETERM': {'id':4, 'description':'machine terminal voltage (pu).'},
        'EFD':   {'id':5, 'description':'generator main field voltage (pu).'},
        'PMECH': {'id':6, 'description':'turbine mechanical power (pu on MBASE).', 'name':'p_m', 'latex':'p_m'},
        'SPEED': {'id':7, 'description':'machine speed deviation from nominal (pu).'},
        'XADIFD':{'id':8, 'description':'machine field current (pu).'},
        'ECOMP': {'id':9, 'description':'voltage regulator compensated voltage (pu).'},
        'VOTHSG':{'id':10,'description':'stabilizer output signal (pu).',  'name':'v_pss', 'latex':'v_s'},
        'VREF':  {'id':11,'description':'voltage regulator voltage setpoint (pu).', 'name':'v_ref', 'latex':'v^\star'},
        'BSFREQ':{'id':12,'description':'bus pu frequency deviations.'},
        'VOLT':  {'id':13,'description':'bus pu voltages (complex).', 'name':'volt', 'latex':'v_b'},
        'ITERM': {'id':21,'description':'', 'name':'iterm'},
        'VUEL':  {'id':23,'description':'minimum excitation limiter output signal (pu).', 'name':'vuel'},
        'VOEL':  {'id':24,'description':'maximum excitation limiter output signal (pu).', 'name':'voel'},
        'PLOAD ':{'id':25,'description':'', 'name':'p_load', 'latex':'p_l'},
        'QLOAD': {'id':26,'description':'', 'name':'q_load', 'latex':'q_l'},
        'GREF':  {'id':27,'description':'turbine governor reference.', 'name':'gref', 'latex':'p_g^\star'}
        }
       
        self.chan_ids = chan_ids
        # se definen los canales       
        self.chan_vars = ['ANGLE','SPEED','VOLT','PELEC','QELEC']
        for item in self.chan_vars:
             
            self.psspy.chsb(0,1,[-1,-1,-1,1,chan_ids[item]['id'],0])

  
    def run_fault(self, bus_fault=1, fault_duration=0.05, to_bus=2, line_id='1 '):

         
        # se inicializa el sistema
        self.psspy.strt(0,self.outfile1)
        
        # comienza la simulacion
        self.psspy.run(0, 0.2,1000,1,0)
        
        # se aplica la falta
        self.psspy.dist_bus_fault(bus_fault,1, 400.0,[0.0,-0.2E+10])
        self.psspy.run(0, 0.2+fault_duration,1000,1,0)
        
        # se quita la falta y se quita la linea 
        self.psspy.dist_clear_fault(1)
        self.psspy.dist_branch_trip(bus_fault,to_bus,line_id)
        self.psspy.run(0, 5.0,1000,1,1)

        
        self.chnf = self.dyntools.CHNF(self.outfile1)

    def tear_down(self):
        '''
        theta_9  = np.array(chnf.get_data()[2][name2chan(chnf,'ANGL',  9)])
        theta_10 = np.array(chnf.get_data()[2][name2chan(chnf,'ANGL', 10)])
        theta_11 = np.array(chnf.get_data()[2][name2chan(chnf,'ANGL', 11)])
        theta_12 = np.array(chnf.get_data()[2][name2chan(chnf,'ANGL', 12)])
        speed_9  = np.array(chnf.get_data()[2][name2chan(chnf,'SPD',  9)])
        speed_10 = np.array(chnf.get_data()[2][name2chan(chnf,'SPD', 10)])
        speed_11 = np.array(chnf.get_data()[2][name2chan(chnf,'SPD', 11)])
        speed_12 = np.array(chnf.get_data()[2][name2chan(chnf,'SPD', 12)])
        volt_9  = np.array(chnf.get_data()[2][name2chan(chnf,'VOLT',  9)])
        volt_10 = np.array(chnf.get_data()[2][name2chan(chnf,'VOLT', 10)])
        volt_11 = np.array(chnf.get_data()[2][name2chan(chnf,'VOLT', 11)])
        volt_12 = np.array(chnf.get_data()[2][name2chan(chnf,'VOLT', 12)])
        p_gen_9  = np.array(chnf.get_data()[2][name2chan(chnf,'POWR',  9)])
        p_gen_10 = np.array(chnf.get_data()[2][name2chan(chnf,'POWR', 10)])
        p_gen_11 = np.array(chnf.get_data()[2][name2chan(chnf,'POWR', 11)])
        p_gen_12 = np.array(chnf.get_data()[2][name2chan(chnf,'POWR', 12)])
        q_gen_9  = np.array(chnf.get_data()[2][name2chan(chnf,'VARS',  9)])
        q_gen_10 = np.array(chnf.get_data()[2][name2chan(chnf,'VARS', 10)])
        q_gen_11 = np.array(chnf.get_data()[2][name2chan(chnf,'VARS', 11)])
        q_gen_12 = np.array(chnf.get_data()[2][name2chan(chnf,'VARS', 12)])
        vref_9  = np.array(chnf.get_data()[2][name2chan(chnf,'VREF',  9)])
        vref_10 = np.array(chnf.get_data()[2][name2chan(chnf,'VREF', 10)])
        vref_11 = np.array(chnf.get_data()[2][name2chan(chnf,'VREF', 11)])
        vref_12 = np.array(chnf.get_data()[2][name2chan(chnf,'VREF', 12)])
        p_ref_1 = np.array(chnf.get_data()[2][name2chan(chnf,'VAR', L_vsc_1+4)]) 
        q_ref_1 = np.array(chnf.get_data()[2][name2chan(chnf,'VAR', L_vsc_1+5)])
        p_ref_2 = np.array(chnf.get_data()[2][name2chan(chnf,'VAR', L_vsc_2+4)]) 
        q_ref_2 = np.array(chnf.get_data()[2][name2chan(chnf,'VAR', L_vsc_2+5)])
        p_ref_3 = np.array(chnf.get_data()[2][name2chan(chnf,'VAR', L_vsc_3+4)]) 
        q_ref_3 = np.array(chnf.get_data()[2][name2chan(chnf,'VAR', L_vsc_3+5)])
        '''

        self.chan_data = {}
        for item in self.chan_vars:
            self.chan_data.update()
            self.chan_varsself.psspy.chsb(0,1,[-1,-1,-1,1,chan_ids[item]['id'],0])
            
    
if __name__ == "__main__":
    
    test_1 = Test()
    case_dir = r'E:\jmmauricio\Documents\public\jmmauricio6\RESEARCH\benches\ieee_12_generic\data\ieee12_generic_ac_7_8'
    dll_dir  = r'E:\jmmauricio\Documents\public\jmmauricio6\RESEARCH\benches\ieee_12_generic\data\ieee12_generic_ac_7_8'
    ps_tools_dir  = r'E:\jmmauricio\Documents\public\jmmauricio6\RESEARCH\benches\ieee_12_generic\ps_tools'
    dya_dir = 'avr_pss'
    test_1.setup('ieee12_generic_ac_7_8', case_dir, dll_dir, ps_tools_dir, dya_dir)
    test_1.setup_pf()
    test_1.setup_dyn() 
    test_1.run_fault(bus_fault=1, fault_duration=0.05, to_bus=6, line_id='1 ')
    
   
